var $ytdownloader = jQuery.noConflict(true);

self.port.on('applyNotifications', function(type, selector, content) {
	if (type == 'change') {
		var element = $ytdownloader(selector);
		if (element) {
			element.html(content);
		}
	} else if (type == 'append') {
		var element = $ytdownloader(selector);
		if (element) {
			element.append(content);
		}
	} else if (type == 'remove') {
		var element = $ytdownloader(selector);
		if (element) {
			element.remove();
		}
	}
});

self.port.on('applyActions', function(action) {
	var button = $ytdownloader('#youtube-download-button');
	button.click(function(event) {
		var title = $ytdownloader('#eow-title').text().trim();
		
		$ytdownloader('#download-mp3').text(title + '.mp3');
		$ytdownloader('#download-mp4').text(title + '.mp4');
		
		$ytdownloader('#download-mp3').parent().click(function(event) {
			self.port.emit('doDownload', 'mp3');
		});
		$ytdownloader('#download-mp4').parent().click(function(event) {
			self.port.emit('doDownload', 'mp4');
		});
		
		var buttonOffset = $ytdownloader('#youtube-download-button').offset();
		var panelTop = buttonOffset.top + $ytdownloader('#youtube-download-button').height();
		var panelLeft = buttonOffset.left;
		
		$ytdownloader('#youtube-download-panel').css({top: panelTop, left: panelLeft});
		$ytdownloader('#youtube-download-panel').toggle();
	});
	
	$ytdownloader(document).click(function(event) {
		if (event.target.getAttribute('id') != 'youtube-download-button') {
			$ytdownloader('#youtube-download-panel').hide();
		}
	});
});

self.port.emit('getNotifications', '');

var oldUrl = location.href;

function checkReload() {
	if (oldUrl != location.href) {
		location.reload();
	}
}

// create an observer instance
var observer = new MutationObserver(function(mutations) {
  mutations.forEach(function(mutation) {
   checkReload();
  });    
});
 
// configuration of the observer:
var config = { attributes: false, childList: true, characterData: false };
 
// pass in the target node, as well as the observer options
observer.observe(document.body, config);
